//+------------------------------------------------------------------+
//|                                   Ultimate COT Net Positions.mq4 |
//|                      Copyright  2009, C-4, All Rights Reserved. |
//|                                                   vs-box@mail.ru |
//+------------------------------------------------------------------+

//    .

#property copyright "Copyright  2009, C-4, All Rights Reserved."
#property link      "vs-box@mail.ru"

#property indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Lime
#property  indicator_color2  Blue
#property  indicator_color3  Red
#property  indicator_color4  Silver

//int  period=52;
//int movement_index=6;
extern bool Show_nNoncomm=false;
extern bool Show_nOperators=false;
extern bool Show_nNonrep=false;
extern bool Show_nOI=true;

double i_open_interest[];
double i_noncomm[];
double i_operators[];
double i_nonrep[];

#include <cotlib.mq4>

int init()
{
period=52;
movement_index=6;
   if(init_data()==false)error=true;
   if(error==false)load_data();
   if(error==false)count_data();
   SetParam();
}

int start()
{
   if(error==true)Print("   .   ");
   DrowData();
}

void SetParam()
{
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   IndicatorDigits(0);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   if(load_cot_file==true)IndicatorShortName(StringConcatenate("Meta COT Net Pos.: ", str_trim(cot_file)));
   else IndicatorShortName(StringConcatenate("Meta COT Net Pos.: ", name));
   if(Show_nOI==true){
      SetIndexBuffer(0,i_open_interest);
      SetIndexLabel(0, "Open Interest");
   }
   if(Show_nNoncomm==true){
      SetIndexBuffer(1,i_noncomm);
      SetIndexLabel(1,"Net Noncommercial");
   }
   if(Show_nOperators==true){
      SetIndexBuffer(2,i_operators);
      SetIndexLabel(2,"Net Operators");
   } 
   if(Show_nNonrep==true){
      SetIndexBuffer(3,i_nonrep);
      SetIndexLabel(3,"Net Nonreportable");
   }
}

void DrowData()
{
   int end_data=get_lastdata();
   for(int i=0;i<end_data;i++){
      if(Show_nOI)i_open_interest[i]=get_data(OI, i);
      if(Show_nNoncomm)i_noncomm[i]=get_data(NET_NONCOMM, i);
      if(Show_nOperators)i_operators[i]=get_data(NET_OPERATORS, i);
      if(Show_nNonrep)i_nonrep[i]=get_data(NET_NONREP,i);
   }
}